# $Date: 1995/05/17 08:43:56 $ $Author: kg $ $Revision: 1.6 $ #
#++
AbelianSemiGroup -- the category of abelian semi-groups

An AbelianSemiGroup is a SetCat with an associative and commutative
operation '+'.

Methods:
_plus(x1,x2,...) - returns the sum of x1+x2+...
intmult(x,i)     - returns x+x+...+x (i times) for a positive integer i
++#

AbelianSemiGroup:= CategoryConstructor(
    AbelianSemiGroup,
    [],
    [],
    NIL,
    [ SetCat ],
    [],

    "_plus",

    "intmult" = domains::repeatedSquaring(this, "_plus")

)():

