# $Date: 1995/05/17 08:44:23 $ $Author: kg $ $Revision: 1.7 $ #
#++
Monoid -- the category of monoids

A Monoid is a SemiGroup with a neutral element "one" according to the
operation '*'.

Entries:-
one         - the neutral Element according to '_mult'

Methods:-
invert(x)   - returns FAIL or an y such that x*y = y*x = 1
_power(x,i) - returns x*x*...*x (i times) for a positive integer i,
	      one for i=0 and _power(invert(x), -i) if x is a negative integer
++#

Monoid:= CategoryConstructor(
    Monoid,
    [],
    [],
    NIL,
    [ SemiGroup ],
    [],

    "one", "invert",

    "_power" = domains::repeatedSquaring(this, "_mult", "one", "invert")

)():

