# $Date: 1995/05/17 08:44:26 $ $Author: kg $ $Revision: 1.6 $ #
#++
PartialDifferentialRing -- the category of partial differential rings

PartialDifferentialRing

A partial differential ring is a commutative ring with a finite set
of derivation operators. The derivations are supposed to commute.
They have to be written as follows:

	D([i], f)	ith partial derivation of f

The derivations should return 0 if there is no ith indeterminate of f.

One may further get multiple partial derivations of an element f by:

	D([i1,...,in], f)
	D([], f)

where D([i1,...in], f) is equal to D([i1],...D([in],f)...) and
D([], f) is equal to f.
++#

PartialDifferentialRing:= CategoryConstructor(
    PartialDifferentialRing,
    [ ],
    [ ],
    ( if args(0) <> 0 then error("wrong no of args") end_if ),
    [ CommutativeRing ],
    [ ],

    "D"

)():

