# $Date: 1995/06/28 09:10:45 $ $Author: kg $ $Revision: 1.6.2.1 $ #

#++
getEntry -- get entry of category and change it into domain entry

getEntry(this,e)

this - domain to create entry for
e    - entry name

If the entry is found it is changed into an entry for domain
this and returned: To create a domain entry the formal category
parameters and the ident 'this' in the entry are substituted against
the actual category parameters and the domain this. getEntry returns
[FAIL,FAIL] if no entry with name e is found.

The domain 'this' is used as a global variable by 'getNamedEntry' in
order to get the domain for which to create the entry in that method
(too bad, but hides the details to the category implementor).
++#

CategoryConstructor::getEntry:= proc(this#,e#)
    local _0_C, _0_r;
begin
    for _0_C in (args(1))::categories do

	# search for entry in category constructor #
	if contains(extop(extop(_0_C,1),6), args(2)) then

	    # substitute category args into entry, return result;
	      use index_val to avoid early evaluation of entry definition #
	    _0_r:= CategoryConstructor::subsArgs(
			    index_val(extop(extop(_0_C,1),6), args(2)),
			    _0_C, args(1));

	    if _0_r <> hold(_0_r) then
		return([_0_r, _0_C])
	    end_if;
	end_if;
    end_for;
    [FAIL, FAIL]
end_proc:

# end of file #
