# $Date: 1995/08/16 14:35:34 $ $Author: zimmerma $ $Revision: 1.19.2.2 $ #
#--
intlib::int(f,x) - computes the integral of the function f(x) with respect to 
the variable x.   
--#
intlib::int:=proc(f,_x_)
local opt,n,k_sub,k_ident,k_diff,k_deg,k_alg,Q,Q_sub,i,j,integral,tosubs,hassincos,k,hasI;
begin
# test of input and options #
  if testargs()
    then 
         if domtype(f)<>DOM_IDENT and domtype(f)<>DOM_EXPR
            and not(testtype(f,NUMERIC))
           then error("Illegal integrand"); end_if;
  end_if;
  hassincos:=has(f,{sin,cos}); hasI:=has(f,I);
  # lookup method #
  integral:=intlib::lookup(subs(f,_x_=_X));
  if integral<>FAIL then return(subs(integral,_X=_x_)) end_if;
  opt:=hold(Exp);
  n:=1; k:=[_x_];
  k_sub:=[_x_]; k_ident:=[genident()]; k_diff:=[1]; k_deg:=[0]; k_alg:=[0];
  Q:=[]; Q_sub:=[];
# substitution and construction of the field extensions of the rational numbers#
  f:=intlib::subst(f);
  userinfo(1,"after substitution, integrand is",f);
  repeat i:=intlib::tower(f) until i<>FALSE end_repeat;
  if i=FAIL then return(hold(int)(args())) end_if;
  userinfo(1,"field extension of rational numbers",Q,Q_sub);
  userinfo(1,"tower extension of functions",k,k_sub);
  userinfo(1,"after field extensions, integrand is",i);
  integral:=intlib::intt(i,n);
  if integral=FAIL then return(hold(int)(args())) end_if;
  userinfo(1,"integral is",integral);
  tosubs:=[k_sub[n-i]$hold(i)=0..n-2, Q_sub[nops(Q)-i]$hold(i)=0..nops(Q)-1];
  while has(integral,tosubs) do
     integral:=subs(integral,k_sub[n-i]=k[n-i]$hold(i)=0..n-2,
                       Q_sub[nops(Q)-i]=Q[nops(Q)-i]$hold(i)=0..nops(Q)-1)
  end_while;
  if hasI=FALSE and has(integral,I) then # gets only the real part #
     n:=sign(_x_);
     sign(_x_):=1;
     i:=rectform(integral,{_x_});
     i:=expr(Re(i));
     if not has(i,{Re,Im}) then integral:=i end_if;
     sign(_x_):=(if type(n)<>"sign" then n end_if); # else NIL #
  end_if;
  if hassincos then integral:=combine(expand(intlib::to_sincos(integral,_x_)),sincos) end_if;
  return(integral);
end_proc:
