# $Date: 1995/04/04 15:54:33 $ $Author: kg $ $Revision: 1.10 $ #

# kg, 09/12/93 #

#++
gcdlib -- utilities for GCD calculations

NOTE: This procedures don's check their arguments. They are intended
to be called from other procedures, not from the user.
++#

proc()
local path;
begin

gcdlib:= domain():
gcdlib::name:= "gcdlib":
gcdlib::info:= "Library 'gcdlib': utilities for GCD calculations":
gcdlib::interface:= {}:

# table of random number generators #
gcdlib::gen_random:= table():

# bound for numbers in heuristic GCD #
gcdlib::max_numlen:= (if sysname() = "UNIX" then 3000 else 1000 end_if):

path := pathname("GCDLIB"):

gcdlib::coeff_type:= loadproc(gcdlib::coeff_type, path, "coeftype"):
gcdlib::mod_gcd:= loadproc(gcdlib::mod_gcd, path, "mod_gcd"):
gcdlib::mod_sparse_gcd:= loadproc(gcdlib::mod_sparse_gcd, path, "mod_sgcd"):
gcdlib::mod_dense_gcd:= loadproc(gcdlib::mod_dense_gcd, path, "mod_dgcd"):
gcdlib::poly_mod_content:= loadproc(gcdlib::poly_mod_content, path, "pmodcont"):
gcdlib::univ_mod_gcd:= loadproc(gcdlib::univ_mod_gcd, path, "umod_gcd"):
gcdlib::vanderm_mod_solve:= loadproc(gcdlib::vanderm_mod_solve, path, "vandsolv"):
gcdlib::int_gcd:= loadproc(gcdlib::int_gcd, path, "int_gcd"):
gcdlib::heu_gcd:= loadproc(gcdlib::heu_gcd, path, "heu_gcd"):
gcdlib::int_mod_gcd:= loadproc(gcdlib::int_mod_gcd, path, "int_mgcd"):
gcdlib::dom_gcd:= loadproc(gcdlib::dom_gcd, path, "dom_gcd"):
gcdlib::udom_gcd:= loadproc(gcdlib::udom_gcd, path, "udom_gcd"):
gcdlib::expr2polys:= loadproc(gcdlib::expr2polys, path, "exp2poly"):
gcdlib::special_cases:= loadproc(gcdlib::special_cases, path, "speccase"):
gcdlib::norm_intp:= loadproc(gcdlib::norm_intp, path, "normintp"):
gcdlib::norm_modp:= loadproc(gcdlib::norm_modp, path, "normmodp"):
gcdlib::norm_domp:= loadproc(gcdlib::norm_domp, path, "normdomp"):
gcdlib::min_domain:= loadproc(gcdlib::min_domain, path, "min_dom"):
end_proc():

# end of file #
