# #
# $Date: 1995/05/09 10:22:00 $  $Author: frankp $   $Revision: 1.14 $ #
# #
# frankp, 16/08/94 #

#++
  charpoly.mu

    linalg::charPolynomial() -- returns the characteristic polynomial

	linalg::charPolynomial(A,x)
	
	A: square matrix over a commutative ring
	x: valid polynomial indeterminate
	 
	Computes the characteristic polynomial of the matrix A
	in x, i.e. computes det( x*E(n)-A ), where 'E(n)' is the 
	identity matrix with n=dimen(A).
	The coefficient domain of A has to be a commutative ring.
++#

linalg::charPolynomial := fun(
    (if args(0) <> 2 then
	error("wrong no of args")
    end_if;

    linalg::det( linalg::charMatrix(args()) ))
):

# end of file #
