# #
# $Date: 1995/11/02 21:46:37 $  $Author: frankp $   $Revision: 1.14.2.3 $ #
# #
# frankp, 20.09.1994 #

#++
  nulspace.mu

	linalg::nullSpace  --  compute the kernel of a matrix

	nullSpace(A)

	A: matrix

	linalg::nullSpace(A) computes a basis for the null space
	of A. A must belong to the category Field.
++#

linalg::nullSpace := proc(A)
    name linalg::nullSpace;
    local R, c, l, charIndices, bildIndices, i, j, k, t, ns,
	  MnewThis, Rone, Rnegate;
begin
    if testargs() then
	if args(0) <> 1 then
	    error("wrong no of args")
	end_if;
	if A::hasProp( MatrixCat ) <> TRUE then
	    error("expecting a matrix")
	end_if;
	if not (A::coeffRing)::hasProp( Field ) then
	    error("expecting a matrix over a field")
	end_if
    end_if;

    if A::hasProp( SquareMatrixCat ) then
        MnewThis:= (A::getSuperDomain(A))::newThis
    else
	MnewThis:= A::newThis
    end_if;

    c:= A::dimen(A)[2];
    userinfo(1,"reduce matrix to Gauss-Jordan form");
    l:= linalg::gaussJordan( A,hold(All) );
    A:= l[1];

    charIndices:= l[4];
    if nops( charIndices ) = 0 then
	userinfo(2,"system is determined");
	return( [] )
    end_if;

    R:= A::coeffRing;
    bildIndices:= {j $ j=1..c} minus charIndices union {1};

    userinfo(1,"solve the homogeneous system");
    Rone:= R::one;
    Rnegate:= R::negate;
    j:= 0;
    for i in bildIndices do
        j:= j + 1;
        if j = 1 then
            for k in charIndices do
                # the following order of statements is importent, e.g.
                  linsolve({x=x},{x}) -> bildIndizes=charIndizes={1},
                  hence i = k = 1, ns[1][1]:= 1 !
                #
                ns[k]:= [R::zero $ c ];
                ns[k][i]:= Rnegate( A[j,k] );
                ns[k][k]:= Rone;
            end_for
        else
            for k in charIndices do ns[k][i]:= Rnegate( A[j,k] ) end_for
        end_if
    end_for;
    t:= [];
    for k in charIndices do
        t:= t . [MnewThis(c,1,ns[k])]
    end_for;
    t
end_proc:

# end of file #
