# ok, 25/01/94 #

#++
The Error function

erf(x)

x - an expression
++#

erf := proc(x) 
  local f;
begin
  if x::erf <> FAIL then return(x::erf(args())) end_if;
  if args(0) <> 1 then
     error("1 argument expected");
  end_if;

  case type(x)

    of DOM_INT do
    of DOM_RAT do
        if x < 0 then return(-erf(-x)) end_if;
        break;

    of DOM_FLOAT do
        return(funcattr(erf,"float")(x));
   
    of "_mult" do
        f:= op(x, nops(x));
        if testtype(f, Type::RealNum) then
            if f < 0 then return(-erf(-x)) end_if;
            if domtype(f) = DOM_FLOAT then break end_if;
        else
            break
        end_if;

    end_case;
    procname(x) 
end_proc:

erf(0) := 0:
erf(infinity):=1:
erf(-infinity):=-1:

erf:= funcattr(erf, "print", "erf"):

erf:= funcattr( erf, "conjugate", fun((
    conjugate(args(1));
    if type(%) = "conjugate" then hold(erf)(%)
    else erf(%)
    end_if
)) ):

erf := funcattr( erf, "diff", proc(e)
    local i;
begin
    e:= op(e,1); 2/PI^(1/2) * exp(-e^2) * diff(e, args(i) $ i=2..args(0))
end_proc):

erf := funcattr( erf, "float", fun( 1 - float(erfc(args(1))) ) ):

erf := funcattr( erf, "type", "erf" ):

erf := funcattr( erf, "sign", fun(
    (sign(op(args(1),1));
    if % = 1 then 1
    elif % = -1 then -1
    elif % = 0 then 0
    else hold(sign)(args(1))
    end_if)
)):

erf:= funcattr(erf,"info","erf -- the error function [try ?erf for details]"):

# end of file #
