# $Date: 1995/08/01 16:54:21 $ $Author: zimmerma $ $Revision: 1.10.2.2 $ #

# kg, 13/01/94 #
# ok, 21/01/94 #

#++
sqrt -- the square root

sqrt(x)

x - expression
++#

sqrt:= proc(x)
    name sqrt;
local l,e,f,i,p,k;
begin
    if x::sqrt <> FAIL then return(x::sqrt(args())) end_if;
    if args(0) <> 1 then error("1 argument expected") end_if;

    case type(x)
    of DOM_FLOAT do return(funcattr(sqrt,"float")(x));
    of DOM_COMPLEX do
        if type(op(x, 1)) = DOM_FLOAT or type(op(x, 2)) = DOM_FLOAT then
           return( funcattr(sqrt,"float")(x) )
        end_if;
        break;
    of DOM_RAT do return(sqrt(op(x,1))*sqrt(op(x,2))/op(x,2))
    of DOM_INT do
    of "_plus" do
    of "_mult" do # do not simplify sqrt(x*y) to sqrt(x)*sqrt(y) #
        i:=abs(stdlib::icontent_expr(x)); 
	l:=ifactor(i); e:=1; x:=l[1]*(x/i); f:=1;
	for i from 1 to nops(l) div 2 do
	   p:=op(l,2*i); k:=op(l,2*i+1);
	   f:=f*p^(k div 2); if k mod 2 = 1 then e:=e*p end_if
	end_for;
        if type(x)="_mult" then # look for squares of reals #
           for l in x do
              if type(l)="_power" then
                 if type((i:=op(l,2)/2))=DOM_INT then
                    if contains({"abs"},type((k:=op(l,1)))) then
                       x:=x/l; f:=f*k^i
                    end_if;
                 end_if
              end_if;
           end_for;
        end_if;
	return(f*e^(1/2)*x^(1/2))
    of "_power" do
	e := op(x,2); f := op(x,1);
	if type(e)=DOM_INT then
           if modp(e,2) = 0 then return( (sign(f)*f)^(e/2) ) end_if
        end_if
    end_case;

    x^(1/2)
end_proc:

sqrt:= funcattr(sqrt, "print", "sqrt"):
sqrt:= funcattr(sqrt, "info", "sqrt -- the square root"):

sqrt(I) := (-1)^(1/4):
sqrt(0) := 0:

#--
stdlib::icontent_expr -- get integer contents of an expression

stdlib::icontent_expr(e)

e - expression
--#

stdlib::icontent_expr:= fun((
    case type(args(1))
    of DOM_INT do
	return(args(1));
    of "_plus" do
	return(igcd(map(op(args(1)), stdlib::icontent_expr)));
    of "_mult" do
	op(args(1), nops(args(1)));
	if domtype(%) = DOM_INT then return(%) end_if;
	break;
    of "_power" do
	if domtype(op(args(1),2)) = DOM_INT then
	    if op(args(1),2) > 0 then
		return(stdlib::icontent_expr(op(args(1),1))^op(args(1),2))
	    end_if
	end_if;
    end_case;
    1
)):

# end of file #
