# $Date: 1995/02/22 13:03:08 $ $Author: kg $ $Revision: 1.6 $ #

# kg, 27/12/94 #

#++
userinfo -- print information for user

userinfo(lev,epxr...)

lev  - level of information (positive integer)
expr - expression to print

'userinfo' prints its arguments 'expr...' to the screen if either the
"information level" of the procedure calling 'userinfo' or the "global 
information level" is greater or equal to 'lev'.

The information level (of a procedure or the global one) is defined via
'setuserinfo'. The default level is 0, ie. no information is printed.

The procedure calling 'userinfo' is determined via 'procname'. This
may cause problems is 'procname' doesn't contain the expected value.
++#

userinfo:= fun((
    if stdlib::userinfo_level <> FAIL then
	if contains(stdlib::userinfo_level, procname) then
	    if args(1) <= stdlib::userinfo_level[procname] then
		PRETTY_PRINT;
		PRETTY_PRINT:= FALSE;
		print(Unquoted, procname, args(i) $ hold(i)=2..args(0));
		PRETTY_PRINT:= %3;
	    end_if
	elif contains(stdlib::userinfo_level, hold(Any)) then
	    if args(1) <= stdlib::userinfo_level[hold(Any)] then
		PRETTY_PRINT;
		PRETTY_PRINT:= FALSE;
		print(Unquoted, procname, args(i) $ hold(i)=2..args(0));
		PRETTY_PRINT:= %3;
	    end_if
	end_if
    end_if;
    null())):

# end of file #
