#!/bin/sh

#
# mkINDEX.sh -- make INDEX files for MuPAD library.
#
# Execute in the library directory .../share/lib without
# arguments in order to create the INDEX files needed for
# misk::makelib.
#

#set -x

doSubdir() {
  op=`pwd`
  cd $1
  rm INDEX 2> /dev/null
  touch INDEX
  for dir in *; do
    if [ -d $dir ]; then
	if (doSubdir $dir); then
	    echo 'd:'$dir >> INDEX
	fi
    fi
  done
  ls *.mu 2> /dev/null | sed -e 's/\.mu$//' -e 's/^/f:/' >> INDEX
  cd $op
  if [ !  -s $1/INDEX ]; then
      rm $1/INDEX
  else
      echo created $op/$1/INDEX
  fi
  [ -s $1/INDEX ]
}

doSubdir .

